create or alter procedure LOG_SAVE_EVENT (
    ACAPTION varchar(100),
    ATABLE varchar(50),
    AKEY varchar(50),
    AFIELD varchar(50),
    AOLDVALUE varchar(200),
    ANEWVALUE varchar(200),
    aemployeeid integer)
as
begin
  begin
    insert into EVENTLOG (EVENTLOG_ID, EVENTLOG_KOD_SYSTEMU, EVENTLOG_DATA, EVENTLOG_FORMA, EVENTLOG_TABLICA,
                          EVENTLOG_KLUCZ, EVENTLOG_POLE, EVENTLOG_POLE_NAZWA, EVENTLOG_WARTOSC, EVENTLOG_STARA_WARTOSC,
                          EVENTLOG_OPIS, EVENTLOG_FROM, EVENTLOG_STATUS, SESSION_ID, EMPLOYEE_ID, ZMIANA_ID)
    values (gen_id(SEQ_EVENTLOG, 1), 1, 'NOW', :ACAPTION, :ATABLE, :AKEY, :AFIELD, :AFIELD, :ANEWVALUE, :AOLDVALUE, (select M.MON$REMOTE_ADDRESS
                                                                                                                     from MON$ATTACHMENTS M
                                                                                                                     where M.MON$ATTACHMENT_ID = current_connection),
            'Internal', 0, 0, :aemployeeid, 0);
    when any do
      ANEWVALUE = '';
  end
end