create or alter procedure os_dodaj_osobe (
    aosoba_imiona varchar(100),
    aosoba_nazwisko varchar(100),
    aosoba_email varchar(100),
    aosoba_telefon varchar(100),
    aosoba_adres varchar(250),
    aosoba_miasto varchar(100),
    aosoba_kodpocztowy varchar(20),
    aosoba_kodkraju varchar(20),
    amployee_id integer)
returns (
    oosobaid integer)
as
declare variable osoba_miasto_id integer;
declare variable osoba_panstwo_id integer;
begin
  :OOSOBAID = gen_id(SEQ_OSOBA, 1);
  select MIASTO_ID
  from MIASTO
  where upper(MIASTO_NAZWA) = upper(:AOSOBA_MIASTO)
  into :OSOBA_MIASTO_ID;

  if (OSOBA_MIASTO_ID is null) then
    select MIASTO_ID
    from MIASTO
    where MIASTO_NAZWA = '.' into :OSOBA_MIASTO_ID;/*konwencja*/

if (OSOBA_MIASTO_ID is null) then
  OSOBA_MIASTO_ID = -1;/*tymcza*/

select P.PANSTWO_ID
from PANSTWO P
where upper(P.PANSTWO_KOD) = upper(:AOSOBA_KODKRAJU)
into :OSOBA_PANSTWO_ID;

begin
  insert into OSOBA (OSOBA_ID, OSOBA_KOD_SYSTEMU, OSOBA_RODZAJ_ID, OSOBA_NAZWISKO, OSOBA_IMIONA,
                     OSOBA_NAZWISKO_PANIENSKIE, OSOBA_IMIE_OJCA, OSOBA_IMIE_MATKI, OSOBA_DATA_URODZENIA,
                     OSOBA_MIEJSCE_URODZ_ID, OSOBA_DOWOD_NR, OSOBA_RODZAJDOKT, OSOBA_DOWOD_WYDANY_PRZEZ,
                     OSOBA_OBYWATELSTWO_ID, OSOBA_NIP, OSOBA_NIPPREFIX, OSOBA_PESEL, OSOBA_PLEC_ID, OSOBA_MIASTO_ID,
                     OSOBA_KOD_POCZTOWY, OSOBA_POCZTA_ID, OSOBA_ULICA, OSOBA_NR_DOMU, OSOBA_NR_MIESZKANIA,
                     OSOBA_TELEFON1, OSOBA_TELEFON2, OSOBA_TEL_KOMORKOWY, OSOBA_STANOWISKO, OSOBA_TYTUL,
                     OSOBA_TYTUL_NAUKOWY, OSOBA_CZY_PRACOWNIK, OSOBA_UWAGI, OSOBA_KOGOZAWIADOMIC, OSOBA_EMAIL,
                     OSOBA_ADRES_WWW, OSOBA_ICQ, OSOBA_FAX, OSOBA_KARTAMAGN, OSOBA_ZWROT, LANGUAGE_ID, OSOBA_RABAT,
                     OSOBA_LIMIT, OSOBA_DEF_LIMIT, OSOBA_PUNKTY, OSOBA_AKTYWNY, OSOBA_ZGODA_NPDO, OSOBA_ZGODA_NOIH,
                     OSOBA_ZGODA_EMAIL, OSOBA_STATUS, EMPLOYEE_ID, NADCENNIK_ID, OBIEKT_ID, OSOBA_DATA_WPISU,
                     OSOBA_CZY_SIECIOWY, OSOBA_NUMER_ZEWN, OSOBA_KADRY, OSOBA_EIN, OSOBA_EIN_W, OSOBA_DATA_USUNIECIA,
                     OSOBA_USED)
  values (:OOSOBAID, 1, 0, :AOSOBA_NAZWISKO, :AOSOBA_IMIONA, '', '', '', null, null, null, null, null,
          :OSOBA_PANSTWO_ID, '', '', '', 'M', :OSOBA_MIASTO_ID, :AOSOBA_KODPOCZTOWY, :OSOBA_MIASTO_ID, :AOSOBA_ADRES,
          '', '', :AOSOBA_TELEFON, '', '', null, '', '', 0, 'Online', '', :AOSOBA_EMAIL, '', '', '', '', '', 1, 0, 0, 0,
          0, 1, 1, 1, 1, null, :AMPLOYEE_ID, null, null, cast('NOW' as date), 0, null, 0, '', '', null, 0);
  when any do
    :OOSOBAID = -1;
end
suspend;
end